#ifndef _GUILE_FIXUPS_
#define _GUILE_FIXUPS_

#include <libguile/version.h>

#if SCM_MAJOR_VERSION < 2
#include <guile/gh.h>

#elif SCM_MAJOR_VERSION == 2
#include <libguile.h>

#define gh_scm2int scm_to_int
#define gh_scm2double scm_to_double
#define gh_string_p scm_is_string
#define gh_scm2newstr(a, b) scm_str2string((a))
#define gh_scm2ulong scm_to_ulong
#define gh_car scm_car
#define gh_cdr scm_cdr
#define gh_cadr scm_cadr
#define gh_null_p(l) scm_is_true(scm_null_p((l)))
#define gh_ulong2scm scm_from_ulong
#define gh_double2scm scm_from_double
#define gh_list scm_list_n
#define gh_new_procedure(p, f, nr, no, v) scm_c_define_gsubr((p), (size_t)(f), (nr), (no), (v))
#define gh_load(fname) gh_eval_file(fname)
#define gh_eval_str scm_c_eval_string
#define gh_catch scm_internal_catch
#define gh_str02scm scm_from_locale_string
#define gh_eval_file(f) scm_primitive_load(gh_str02scm((f)));

double *gh_scm2doubles (SCM obj, double *m);

SCM gh_eval_file_with_catch (const char *scheme_code, scm_t_catch_handler handler);
SCM gh_eval_str_with_catch (const char *scheme_code, scm_t_catch_handler handler);

typedef void (*main_prog_t) (int argc, char **argv);
typedef void (*repl_prog_t) (int argc, char **argv);
void gh_enter (int argc, char *argv[], main_prog_t c_main_prog);

#endif // SCM_MAJOR_VERSION

#endif // _GUILE_FIXUPS_
